// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "VNEvent.hpp"
#include "scene/Scene.hpp"
#include "games/vn/components/VNTextboxScroller.hpp"

namespace Dawn {
  class VNTextEvent : public VNEvent {
    public:
      std::string text;

    protected:
      VNTextboxScroller *scroller = nullptr;

      void onStart() override {
        scroller = this->getScene()->findComponent<VNTextboxScroller>();
        assertNotNull(scroller);

        scroller->label->richText = "<font font=\"font_main\" size=\"32\">" + text + "</font>";

        useEvent([&](inputbind_t bind){
          if(bind != INPUT_BIND_ACCEPT) return;
          if(!scroller->readyToClose) return;
          this->next();
        }, this->getScene()->game->inputManager.eventBindPressed);
      }
  };
}