// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "scene/SceneItemComponent.hpp"

namespace Dawn {
  class UIMenuController : public SceneItemComponent {
    private:
      std::function<void()> activeTeardown;

    public:
      StateProperty<bool_t> active;
      StateProperty<int32_t> menuX;
      StateProperty<int32_t> menuY;
      StateProperty<int32_t> columns;
      StateProperty<int32_t> rows;

      StateEvent<int32_t, int32_t> eventItemChange;
      StateEvent<int32_t, int32_t> eventItemSelected;
      StateEvent<> eventMenuCancel;

      UIMenuController(SceneItem *item);
      void onStart() override;
  };
}