// Copyright (c) 2022 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once

#include <SDL.h>
#include "host/DawnHost.hpp"

#define DAWN_SDL2_WINDOW_WIDTH_DEFAULT 1280
#define DAWN_SDL2_WINDOW_HEIGHT_DEFAULT 720

#define DAWN_SDL2_INIT_RESULT_INIT_FAILED -1
#define DAWN_SDL2_INIT_RESULT_WINDOW_CREATE_FAILED -2
#define DAWN_SDL2_START_RESULT_UPDATE_FAILED -3

namespace Dawn {
  class DawnHostData {
    public:
      SDL_Window *window;
      SDL_GLContext glContext;
      bool_t running;
  };
}